local mod = ...



-- Balancing -------------------------------------------------------------------------------------
mod:overrideAsset({
    Id = "DEFAULT_BALANCING",
    StartingTileResourceRequirement = {
        {
            Resource = "BERRIES",
            Quantity = 2
        },
        {
            Resource = "STONE",
            Quantity = 2
        },
        {
            Resource = "WOOD",
            Quantity = 50
        },
    },
    -- PlantableList = {
    --     Action = "APPEND",
    --     "PLANTABLE_PREFAB_TIBERIAS_BERRY1",
    --     "PLANTABLE_PREFAB_TIBERIAS_BERRY2",
    --     "PLANTABLE_PREFAB_TIBERIAS_SAPLING1",
    --     "PLANTABLE_PREFAB_TIBERIAS_SAPLING2",
    --     "PLANTABLE_PREFAB_TIBERIAS_SAPLING3",
    --     "PLANTABLE_PREFAB_TIBERIAS_SAPLING4",
    --     "PLANTABLE_PREFAB_TIBERIAS_SAPLING5",
    --     "PLANTABLE_PREFAB_TIBERIAS_BUSH1",
    --     "PLANTABLE_PREFAB_TIBERIAS_BUSH2",
    --     "PLANTABLE_PREFAB_TIBERIAS_BUSH3",
    --     "PLANTABLE_PREFAB_TIBERIAS_BUSH4",
    --     "PLANTABLE_PREFAB_TIBERIAS_BUSH5",
    -- },
    EventList = {
        Action = "APPEND", 
        "EVENT_TIBERIAS_START",
    },
})

mod:overrideAsset({
    Id = "BUILDING_FUNCTION_FORESTER",
    PlantableAssetList = {
        Action = "APPEND",
        "PLANTABLE_PREFAB_TIBERIAS_BERRY1",
        "PLANTABLE_PREFAB_TIBERIAS_BERRY2",
        "PLANTABLE_PREFAB_TIBERIAS_SAPLING1",
        "PLANTABLE_PREFAB_TIBERIAS_SAPLING2",
        "PLANTABLE_PREFAB_TIBERIAS_SAPLING3",
        "PLANTABLE_PREFAB_TIBERIAS_SAPLING4",
        "PLANTABLE_PREFAB_TIBERIAS_SAPLING5",
        "PLANTABLE_PREFAB_TIBERIAS_BUSH1",
        "PLANTABLE_PREFAB_TIBERIAS_BUSH2",
        "PLANTABLE_PREFAB_TIBERIAS_BUSH3",
        "PLANTABLE_PREFAB_TIBERIAS_BUSH4",
        "PLANTABLE_PREFAB_TIBERIAS_BUSH5",
    },
})


-- Event: Start ---------------------------------------------------------------------------------------------
mod:registerAssetId("models/Notification.png", "TEXTURE_TIBERIAS_NOTIFICATION")

mod:registerAsset({
    DataType = "EVENT",
    Id = "EVENT_TIBERIAS_START",
    Title = "EVENT_TIBERIAS_START_TITLE",
    Description = "EVENT_TIBERIAS_START_DESC",
    IsInMainPool = false,
    IsRecurrent = false,
    DaysToFirst = 1,
    ConditionList = {
    },
	ActionList = {
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                DataType = "DATA_NARRATIVE_PANEL",
                Title = "EVENT_TIBERIAS_START_TITLE",
                Description = "EVENT_TIBERIAS_START_DESC",
                PanelVisual = "TEXTURE_TIBERIAS_NOTIFICATION",
            },
            ChoiceList = {
                {
                    DataType = "EVENT_CHOICE",
                    ShortName = "EVENT_TIBERIAS_CHOICE_1",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_IGNORE"
                        },
                    },
               },
            },
        },
    },
})



-- Vegetation, Stones, Bushes -------------------------------------------------------------------------------------
function registerPlant(meshName, prefabName, resourceName, plantingDistance, radiusDistance, resourceQty, availableQty)

    mod:registerAssetId("models/Bush1.fbx/Prefab/" .. meshName, prefabName)
    mod:registerPrefabComponent("models/Bush1.fbx/Prefab/" .. meshName, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = plantingDistance })
    mod:registerPrefabComponent("models/Bush1.fbx/Prefab/" .. meshName, { DataType = "COMP_TREE" })

    mod:registerAsset({
        DataType = "PLANTABLE",
        Id = "PLANTABLE_" .. prefabName,
        Name = "PLANTABLE_" .. prefabName,
        PlantPrefab = prefabName,
        Icon = "ICON_RESOURCE_" .. resourceName,
        MinimumScale = 0.85, -- min size at full growth
        MaximumScale = 1.15 -- max size at full growth
    })

    mod:registerPrefabComponent( "models/Bush1.fbx/Prefab/" .. meshName, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = resourceName,
        IsReplenishable = false,
        ResourceValue = resourceQty, -- how many are gathered with each pick
        AvailableQuantity = availableQty, -- maximum container stock
        Radius = radiusDistance, -- distance from container that the villager will stand to pick
        IsDestroyWhenEmpty = true,
    })    
    
end

registerPlant("Bush.001", "PREFAB_TIBERIAS_BUSH1", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Bush.002", "PREFAB_TIBERIAS_BUSH2", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Bush.003", "PREFAB_TIBERIAS_BUSH3", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Bush.004", "PREFAB_TIBERIAS_BUSH4", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Bush.005", "PREFAB_TIBERIAS_BUSH5", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Sapling.001", "PREFAB_TIBERIAS_SAPLING1", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Sapling.002", "PREFAB_TIBERIAS_SAPLING2", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Sapling.003", "PREFAB_TIBERIAS_SAPLING3", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Sapling.004", "PREFAB_TIBERIAS_SAPLING4", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Sapling.005", "PREFAB_TIBERIAS_SAPLING5", "WOOD", 2, 1.2, 0.5, 1)
registerPlant("Stone.001", "PREFAB_TIBERIAS_STONE1", "STONE", 1, 1.2, 1, 10)
registerPlant("Stone.002", "PREFAB_TIBERIAS_STONE2", "STONE", 1, 1.2, 1, 14)
registerPlant("Stone.003", "PREFAB_TIBERIAS_STONE3", "STONE", 1, 1.2, 1, 8)
registerPlant("Stone.004", "PREFAB_TIBERIAS_STONE4", "STONE", 1, 1.2, 1, 10)
registerPlant("Stone.005", "PREFAB_TIBERIAS_STONE5", "STONE", 1, 1.2, 1, 16)



-- Berry Bushes -------------------------------------------------------------------------------------
function registerBerry(meshName, prefabName, resourceName, plantingDistance, radiusDistance, resourceQty, availableQty)

    mod:registerAssetId("models/Bush1.fbx/Prefab/" .. meshName, prefabName)
    mod:registerPrefabComponent("models/Bush1.fbx/Prefab/" .. meshName, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = plantingDistance })
    mod:registerPrefabComponent("models/Bush1.fbx/Prefab/" .. meshName, { DataType = "COMP_TREE" })

    mod:registerAsset({
        DataType = "PLANTABLE",
        Id = "PLANTABLE_" .. prefabName,
        Name = "PLANTABLE_" .. prefabName,
        PlantPrefab = prefabName,
        Icon = "ICON_RESOURCE_" .. resourceName,
        MinimumScale = 0.85, -- min size at full growth
        MaximumScale = 1.15 -- max size at full growth
    })

    mod:registerPrefabComponent( "models/Bush1.fbx/Prefab/" .. meshName, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = resourceName,
        IsReplenishable = true,
        ReplenishDurationInDays = 7,
        ReplenishQuantity = availableQty,
        ResourceValue = resourceQty, -- how many are gathered with each pick
        AvailableQuantity = availableQty, -- maximum container stock
        Radius = radiusDistance, -- distance from container that the villager will stand to pick
        IsDestroyWhenEmpty = false,
    })    
    
end

registerBerry("BerryBush.001", "PREFAB_TIBERIAS_BERRY1", "BERRIES", 2, 1.2, 2, 10)
registerBerry("BerryBush.002", "PREFAB_TIBERIAS_BERRY2", "BERRIES", 2, 1.2, 2, 10)



-- Minerals -------------------------------------------------------------------------------------
function registerMineral(meshName, prefabName, resourceName, plantingDistance, radiusDistance, resourceQty, availableQty)

    mod:registerAssetId("models/Mineral1.fbx/Prefab/" .. meshName, prefabName)
    mod:registerPrefabComponent("models/Mineral1.fbx/Prefab/" .. meshName, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = plantingDistance })
    mod:registerPrefabComponent("models/Mineral1.fbx/Prefab/" .. meshName, { DataType = "COMP_TREE" })

    mod:registerAsset({
        DataType = "PLANTABLE",
        Id = "PLANTABLE_" .. prefabName,
        Name = "PLANTABLE_" .. prefabName,
        PlantPrefab = prefabName,
        Icon = "ICON_RESOURCE_" .. resourceName,
        MinimumScale = 0.85, -- min size at full growth
        MaximumScale = 1.15 -- max size at full growth
    })

    mod:registerPrefabComponent( "models/Mineral1.fbx/Prefab/" .. meshName, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = resourceName,
        IsReplenishable = false,
        ResourceValue = resourceQty, -- how many are gathered with each pick
        AvailableQuantity = availableQty, -- maximum container stock
        Radius = radiusDistance, -- distance from container that the villager will stand to pick
        IsDestroyWhenEmpty = true,
    })    
    
end

registerMineral("Gold.001", "PREFAB_TIBERIAS_GOLD1", "GOLD_ORE", 1, 3.5, 1, 100)
registerMineral("Gold.002", "PREFAB_TIBERIAS_GOLD2", "GOLD_ORE", 1, 3.5, 1, 100)
registerMineral("Gold.003", "PREFAB_TIBERIAS_GOLD3", "GOLD_ORE", 1, 3.5, 1, 100)
registerMineral("Iron.001", "PREFAB_TIBERIAS_IRON1", "IRON_ORE", 1, 2.0, 1, 60)
registerMineral("Iron.002", "PREFAB_TIBERIAS_IRON2", "IRON_ORE", 1, 2.0, 1, 60)
registerMineral("Iron.003", "PREFAB_TIBERIAS_IRON3", "IRON_ORE", 1, 2.0, 1, 60)
registerMineral("Quartz.001", "PREFAB_TIBERIAS_QUARTZ1", "QUARTZ", 1, 2.5, 1, 100)
registerMineral("Quartz.002", "PREFAB_TIBERIAS_QUARTZ2", "QUARTZ", 1, 2.5, 1, 100)
registerMineral("Quartz.003", "PREFAB_TIBERIAS_QUARTZ3", "QUARTZ", 1, 2.5, 1, 100)
registerMineral("Marble.001", "PREFAB_TIBERIAS_MARBLE1", "MARBLE", 1, 3.5, 1, 120)
registerMineral("Marble.002", "PREFAB_TIBERIAS_MARBLE2", "MARBLE", 1, 3.5, 1, 120)
registerMineral("Marble.003", "PREFAB_TIBERIAS_MARBLE3", "MARBLE", 1, 3.5, 1, 120)



-- Fertility inhibitor -------------------------------------------------------------------------------------
mod:registerAssetId("models/Bush1.fbx/Prefab/Blank", "PREFAB_TIBERIAS_BLANK")
mod:registerPrefabComponent("models/Bush1.fbx/Prefab/Blank", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 20 })
mod:registerPrefabComponent("models/Bush1.fbx/Prefab/Blank", { DataType = "COMP_TREE" })

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_BLANK",
    Name = "PLANTABLE_BLANK_NAME",
    PlantPrefab = "PREFAB_TIBERIAS_BLANK",
    Icon = "ICON_RESOURCE_WOOD",
    MinimumScale = 1, -- min size at full growth
    MaximumScale = 1 -- max size at full growth
})

mod:registerPrefabComponent( "models/Bush1.fbx/Prefab/Blank", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WATER",
    IsReplenishable = false,
    ResourceValue = 0, -- how many are gathered with each pick
    AvailableQuantity = 0, -- maximum container stock
    Radius = 1.25, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
})    



-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/Bush1.fbx/Materials/Material.Bush1", "MATERIAL_TIBERIAS_BUSH1")
mod:registerAssetId("models/Bush1.fbx/Materials/Material.Bush2", "MATERIAL_TIBERIAS_BUSH2")
mod:registerAssetId("models/Bush1.fbx/Materials/Material.Bush3", "MATERIAL_TIBERIAS_BUSH3")
mod:registerAssetId("models/Bush1.fbx/Materials/Material.Tree1", "MATERIAL_TIBERIAS_TREE1")

mod:overrideAsset({ Id = "MATERIAL_TIBERIAS_BUSH1", HasAlphaTest = true, })
mod:overrideAsset({ Id = "MATERIAL_TIBERIAS_BUSH2", HasAlphaTest = true, })
mod:overrideAsset({ Id = "MATERIAL_TIBERIAS_BUSH3", HasAlphaTest = true, })
mod:overrideAsset({ Id = "MATERIAL_TIBERIAS_TREE1", HasAlphaTest = true, })



-- Maps -------------------------------------------------------------------------------------
mod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mod:registerAssetId("maps/infertility_density.png", "INFERTILITY_MAP")
mod:registerAssetId("maps/bush_density.png", "BUSH_MAP")
mod:registerAssetId("maps/tree_density.png", "TREE_MAP")
mod:registerAssetId("maps/sapling_density.png", "SAPLING_MAP")
mod:registerAssetId("maps/stone_density.png", "STONE_MAP")
mod:registerAssetId("maps/iron_density.png", "IRON_MAP")
mod:registerAssetId("maps/gold_density.png", "GOLD_MAP")
mod:registerAssetId("maps/quartz_density.png", "QUARTZ_MAP")
mod:registerAssetId("maps/marble_density.png", "MARBLE_MAP")



-- Register custom map
mod:registerAsset({
	DataType = "CUSTOM_MAP",
	Id = "MAP_TIBERIAS",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -22,
	MaxHeight = 110,
	VillagePathList = {
		{
			Entrance = { 300, 0, 1013 },
			Exit = { 300, 0, 13 },
		},
		{
			Entrance = { 400, 0, 1013 },
			Exit = { 400, 0, 13 },
		},
		{
			Entrance = { 500, 0, 1013 },
			Exit = { 500, 0, 13 },
		},
		{
			Entrance = { 600, 0, 1013 },
			Exit = { 600, 0, 13 },
		},
		{
			Entrance = { 700, 0, 1013 },
			Exit = { 700, 0, 13 },
		},
		{
			Entrance = { 800, 0, 1013 },
			Exit = { 800, 0, 13 },
		},
		{
			Entrance = { 900, 0, 1013 },
			Exit = { 900, 0, 13 },
		}
	},

    SpawnList = {
	},

    DensitySpawnList = {

		{
			-- Infertility (farms will never grow crops here)
			DensityMap = "INFERTILITY_MAP",
			Density = 1.0,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_BLANK" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 1.0,
                        Max = 1.0
                    },
                    OrientationRange = {
                        Min = { 0, 0, 0 },
                        Max = { 0, 0, 0 }
                    },
                    ScaleRange = {
                        Min = 1,
                        Max = 1
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                }
			}
		},

		{
			-- Bushes (small amount of wood, inhibits farming until cleared)
			DensityMap = "BUSH_MAP",
			Density = 0.5,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_BUSH1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.50,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_BUSH2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.50,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_BUSH3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.50,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_BUSH4" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.50,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_BUSH5" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.50,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_BERRY1" },
                    RandomWeight = 0.3,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 1.0,
                        Max = 1.1,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_BERRY2" },
                    RandomWeight = 0.3,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 1.0,
                        Max = 1.1,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
			}
		},

        {
			-- Saplings (small amount of wood, inhibits farming until cleared)
			DensityMap = "SAPLING_MAP",
			Density = 0.7,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_SAPLING1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.75,
                        Max = 1.25,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_SAPLING2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.75,
                        Max = 1.25,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_SAPLING3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.75,
                        Max = 1.25,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_SAPLING4" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.75,
                        Max = 1.25,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_SAPLING5" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.75,
                        Max = 1.25,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
			}
		},

        {
			-- Trees
			DensityMap = "TREE_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TREE_PINE" },
                    RandomWeight = 3.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TREE_OAK" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TREE_POPLAR" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TREE_SYCAMORE" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
			}
		},

        
		{
			-- Stones (small amount of stone, inhibits farming until cleared)
			DensityMap = "STONE_MAP",
			Density = 0.6,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_STONE1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_STONE2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_STONE3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_STONE4" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_STONE5" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
			}
		},

        -- {
		-- 	-- Create rock outcrops - stone resource
		-- 	DensityMap = "ROCK_DENSITY_MAP",
		-- 	Density =0.9,
		-- 	PrefabConfigList = {
		-- 		{
		-- 				PrefabList = { "PREFAB_RESOURCE_ROCK" },
		-- 				RandomWeight = 0.1,
		-- 				OffsetSizeRange = {
		-- 					Min = 0.75,
		-- 					Max = 1.0
		-- 			},
		-- 				OrientationRange = {
		-- 					Min = { 0, -180, 0 },
		-- 					Max = { 0, 180, 0 }
		-- 			},
		-- 				ScaleRange = {
        --                     Min = 1.10,
        --                     Max = 1.20,
        --                 },
		-- 				ColorRange = {
		-- 					Min = { 0.8, 0.8, 0.8, 1 },
		-- 					Max = { 1, 1, 1, 1 }
		-- 			}
		-- 		}
		-- 	}
		-- },

		{
			-- Gold ore
			DensityMap = "GOLD_MAP",
			Density = 0.5,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_GOLD1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_GOLD2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_GOLD3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
			}
		},

        {
			-- Iron ore
			DensityMap = "IRON_MAP",
			Density = 0.85,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_IRON1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_IRON2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_IRON3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
			}
		},

        {
			-- Quartz
			DensityMap = "QUARTZ_MAP",
			Density = 0.5,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_QUARTZ1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_QUARTZ2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_QUARTZ3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
			}
		},

        {
			-- Marble
			DensityMap = "MARBLE_MAP",
			Density = 0.35,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TIBERIAS_MARBLE1" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_MARBLE2" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
				{
                    PrefabList = { "PREFAB_TIBERIAS_MARBLE3" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
			}
		},

        {
			-- Fish
			DensityMap = "FISH_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
                            Min = 0.75,
                            Max = 1.00,
                        },
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})



